# Data Analysis Package

## Overview

This data analysis package provides tools for preprocessing, feature engineering, clustering, and feature selection/reduction of data. It includes functionalities for validating data structure, handling missing values, removing outliers, scaling data, and more. The package is designed to streamline and automate common data analysis tasks, making it easier to prepare data for further analysis and machine learning.

## Features

- **Data Preprocessing**
  - Data structure validation
  - Null value removal
  - Outlier removal
  - Data scaling

- **Feature Engineering**
  - RFM (Recency, Frequency, Monetary) calculation
  - Velocity calculation
  - Growth calculation

- **Feature Selection and Reduction**
  - Information gain calculation
  - WOE (Weight of Evidence) and IV (Information Value) calculation
  - PCA (Principal Component Analysis) application and inverse transformation

- **Advanced Clustering**
  - Selection of best clustering method (e.g., KMeans, DBSCAN, EM, MeanShift, Agglomerative)
  - Elbow and Silhouette method for optimal cluster number selection







